Core - Bug # 68562

Epic # 68397 (In Progress): Make TYPO3 work with MySQL strict mode

Status: New Priority: Should have
Author: Morton Jonuschat Category: Database API
Created: 2015-07-27 Assigned To: Morton Jonuschat
Updated: 2015-08-03 Due date:

TYPO3 Version: 7

PHP Version: 5.6

Complexity:

Is Regression: No

Sprint Focus:

Subject: Bool values need to be cast to integer for MySQL strict mode

Description

MySQL strict mode doesn't accept " as a valid value to store in an integer column if the MySQL is run in strict mode.
Boolean values are cast by mysqli_real_escape string to '1' (for TRUE) and " (for FALSE). Due to this special handling is required for
boolean values to result in '0' and '1' for FALSE/TRUE

Related issues:
related to Core - Bug # 68418: scheduler chokes on mysq| strict mode Resolved 2015-07-21
related to Core - Bug # 68602: NULL values in records get transformed to FALS... New 2015-07-29

Associated revisions

Revision cc72fd7e - 2015-07-28 22:33 - Morton Jonuschat

[BUGFIX] Database API: Cast bool values to integer for MySQL

Convert boolean values to integers before processing them with
mysqli_real_escape_string() to ensure that FALSE values get converted to
'0" instead of ", which isn't a valid value for integer columns in

MySQL strict mode.

Resolves: #68562

Releases: master

Change-Id: 1974ebebbc82ab54d2dd89a792536b0401eb1c81e
Reviewed-on: http://review.typo3.org/41993

Reviewed-by: Wouter Wolters <typo3@wouterwolters.nl>

Reviewed-by: Daniel Goerz <ervaude@gmail.com>

Reviewed-by: Tomas Norre Mikkelsen <tomasnorre@gmail.com>

Tested-by: Daniel Goerz <ervaude@gmail.com>

Reviewed-by: Stefan Neufeind <typo3.neufeind@speedpartner.de>

Tested-by: Stefan Neufeind <typo3.neufeind@speedpartner.de>

History

#1 - 2015-07-27 20:09 - Morton Jonuschat
- Status changed from New to In Progress

#2 - 2015-07-27 20:33 - Gerrit Code Review

- Status changed from In Progress to Under Review
Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/41993

#3 - 2015-07-28 22:38 - Morton Jonuschat
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:cc72fd7e874c44bbd6ffédd17c0b3ef6cdfb3623.

#4 - 2015-07-28 23:07 - Christian Kuhn

- Status changed from Resolved to New

patch was unfortunately reverted with https://review.typo3.org/#/c/42076/

#5 - 2015-07-29 09:32 - Morton Jonuschat

After discussion with Stefan Neufeind the initial implementation is still the best way to go, but the bug(s) in EXT:impexp need to be fixed first.

Additionally this should be marked as breaking to be on the safe side.

#6 - 2015-08-03 09:28 - Marc Bastian Heinrichs

Link to the failing tests https:/travis-ci.org/TYPO3/TYPO3.CMS/jobs/73080775
